# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re




# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class AppCredentialSignedjwt(object):
    """
    @undocumented: swagger_types
    @undocumented: attribute_map
    @undocumented: to_dict
    @undocumented: to_str
    @undocumented: __repr__
    @undocumented: __eq__
    @undocumented: __ne__
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'valid_issuers': 'list[str]',
        'signing_keys': 'AppCredentialSignedjwtSigningKeys'
    }

    attribute_map = {
        'valid_issuers': 'valid_issuers',
        'signing_keys': 'signing_keys'
    }

    def __init__(self, valid_issuers=None, signing_keys=None):
        """
        AppCredentialSignedjwt - a model defined in Swagger
        """

        self._valid_issuers = None
        self._signing_keys = None

        self.valid_issuers = valid_issuers
        if signing_keys is not None:
          self.signing_keys = signing_keys

    @property
    def valid_issuers(self):
        """
        Gets the valid_issuers of this AppCredentialSignedjwt.
        An array of valid issuers. JWT presented for authentication must have one of these issuers.

        Type: list[L{str}]
        """
        return self._valid_issuers

    @valid_issuers.setter
    def valid_issuers(self, valid_issuers):
        """
        Sets the valid_issuers of this AppCredentialSignedjwt.
        An array of valid issuers. JWT presented for authentication must have one of these issuers.
        """

        self._valid_issuers = valid_issuers

    @property
    def signing_keys(self):
        """
        Gets the signing_keys of this AppCredentialSignedjwt.

        Type: L{AppCredentialSignedjwtSigningKeys}
        """
        return self._signing_keys

    @signing_keys.setter
    def signing_keys(self, signing_keys):
        """
        Sets the signing_keys of this AppCredentialSignedjwt.
        """

        self._signing_keys = signing_keys

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, AppCredentialSignedjwt):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

