# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re




# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class AppCredentialSignedjwtSigningKeys(object):
    """
    @undocumented: swagger_types
    @undocumented: attribute_map
    @undocumented: to_dict
    @undocumented: to_str
    @undocumented: __repr__
    @undocumented: __eq__
    @undocumented: __ne__
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'kind': 'JWTSigningKeyType',
        'keys': 'dict(str, str)',
        'url': 'str',
        'cache_duration': 'int'
    }

    attribute_map = {
        'kind': 'kind',
        'keys': 'keys',
        'url': 'url',
        'cache_duration': 'cache_duration'
    }

    def __init__(self, kind=None, keys=None, url=None, cache_duration=None):
        """
        AppCredentialSignedjwtSigningKeys - a model defined in Swagger
        """

        self._kind = None
        self._keys = None
        self._url = None
        self._cache_duration = None

        self.kind = kind
        if keys is not None:
          self.keys = keys
        if url is not None:
          self.url = url
        if cache_duration is not None:
          self.cache_duration = cache_duration

    @property
    def kind(self):
        """
        Gets the kind of this AppCredentialSignedjwtSigningKeys.
        Type of signing key, fetched or stored

        Type: L{JWTSigningKeyType}
        """
        return self._kind

    @kind.setter
    def kind(self, kind):
        """
        Sets the kind of this AppCredentialSignedjwtSigningKeys.
        Type of signing key, fetched or stored
        """

        self._kind = kind

    @property
    def keys(self):
        """
        Gets the keys of this AppCredentialSignedjwtSigningKeys.
        In case of \"stored\" kind, a map of key ids (arbitrary strings) to base64-encoded DER keys

        Type: map[L{str}]
        """
        return self._keys

    @keys.setter
    def keys(self, keys):
        """
        Sets the keys of this AppCredentialSignedjwtSigningKeys.
        In case of \"stored\" kind, a map of key ids (arbitrary strings) to base64-encoded DER keys
        """

        self._keys = keys

    @property
    def url(self):
        """
        Gets the url of this AppCredentialSignedjwtSigningKeys.
        In case of \"fetched\" kind, URL for fetching public key for verification of JWT signature

        Type: L{str}
        """
        return self._url

    @url.setter
    def url(self, url):
        """
        Sets the url of this AppCredentialSignedjwtSigningKeys.
        In case of \"fetched\" kind, URL for fetching public key for verification of JWT signature
        """

        self._url = url

    @property
    def cache_duration(self):
        """
        Gets the cache_duration of this AppCredentialSignedjwtSigningKeys.
        In case of \"fetched\" kind, duration for which the public key can be cached

        Type: L{int}
        """
        return self._cache_duration

    @cache_duration.setter
    def cache_duration(self, cache_duration):
        """
        Sets the cache_duration of this AppCredentialSignedjwtSigningKeys.
        In case of \"fetched\" kind, duration for which the public key can be cached
        """

        self._cache_duration = cache_duration

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, AppCredentialSignedjwtSigningKeys):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

