# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re




# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class ApprovalRequestRequest(object):
    """
    @undocumented: swagger_types
    @undocumented: attribute_map
    @undocumented: to_dict
    @undocumented: to_str
    @undocumented: __repr__
    @undocumented: __eq__
    @undocumented: __ne__
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'operation': 'str',
        'method': 'str',
        'body': 'object',
        'description': 'str'
    }

    attribute_map = {
        'operation': 'operation',
        'method': 'method',
        'body': 'body',
        'description': 'description'
    }

    def __init__(self, operation=None, method=None, body=None, description=None):
        """
        ApprovalRequestRequest - a model defined in Swagger
        """

        self._operation = None
        self._method = None
        self._body = None
        self._description = None

        self.operation = operation
        if method is not None:
          self.method = method
        if body is not None:
          self.body = body
        if description is not None:
          self.description = description

    @property
    def operation(self):
        """
        Gets the operation of this ApprovalRequestRequest.
        Operation URL path, e.g. `/crypto/v1/keys`, `/crypto/v1/groups/<id>`.

        Type: L{str}
        """
        return self._operation

    @operation.setter
    def operation(self, operation):
        """
        Sets the operation of this ApprovalRequestRequest.
        Operation URL path, e.g. `/crypto/v1/keys`, `/crypto/v1/groups/<id>`.
        """

        self._operation = operation

    @property
    def method(self):
        """
        Gets the method of this ApprovalRequestRequest.
        Method for the operation: POST, PATCH, PUT, DELETE, or GET. Default is POST. 

        Type: L{str}
        """
        return self._method

    @method.setter
    def method(self, method):
        """
        Sets the method of this ApprovalRequestRequest.
        Method for the operation: POST, PATCH, PUT, DELETE, or GET. Default is POST. 
        """

        self._method = method

    @property
    def body(self):
        """
        Gets the body of this ApprovalRequestRequest.

        Type: L{object}
        """
        return self._body

    @body.setter
    def body(self, body):
        """
        Sets the body of this ApprovalRequestRequest.
        """

        self._body = body

    @property
    def description(self):
        """
        Gets the description of this ApprovalRequestRequest.
        Optional comment about the approval request for the reviewer.

        Type: L{str}
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this ApprovalRequestRequest.
        Optional comment about the approval request for the reviewer.
        """

        self._description = description

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ApprovalRequestRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

