# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re

from .base_enum_object import BaseEnumObject

# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class CryptMode(BaseEnumObject):
    """
    &#x60;CipherMode&#x60; or &#x60;RsaEncryptionPadding&#x60;, depending on the encryption algorithm

    Enumeration values::
        CryptMode.ECB = "ECB"
        CryptMode.CBC = "CBC"
        CryptMode.CBCNOPAD = "CBCNOPAD"
        CryptMode.CFB = "CFB"
        CryptMode.CTR = "CTR"
        CryptMode.OFB = "OFB"
        CryptMode.GCM = "GCM"
        CryptMode.CCM = "CCM"
        CryptMode.PKCS1_V15 = "PKCS1_V15"
        CryptMode.OAEP_MGF1_SHA1 = "OAEP_MGF1_SHA1"
        CryptMode.OAEP_MGF1_SHA256 = "OAEP_MGF1_SHA256"
        CryptMode.OAEP_MGF1_SHA384 = "OAEP_MGF1_SHA384"
        CryptMode.OAEP_MGF1_SHA512 = "OAEP_MGF1_SHA512"
        CryptMode.FPE = "FPE"
        CryptMode.KW = "KW"
        CryptMode.KWP = "KWP"

    This class doesnt use python standard enumeration since they dont support unknown values. 
    
    This is an object of type BaseEnumObject and provides similar functionality as a String Enumeration.
    
    Get a standard instance of enum: CryptMode.FOO or CryptMode("FOO")
    Get non standard instance of enum: CryptMode("BAR")
    Enum instance to String value: CryptMode.FOO.value , CryptMode.FOO.name (Gives "FOO")
    Equality: CryptMode.FOO == CryptMode("FOO") , CryptMode.FOO != CryptMode.BAR
    Provides str func:  str(CryptMode.FOO) == "CryptMode.FOO"
    
    Also the class maintains a static dict of values. hence CryptMode.FOO and CryptMode("FOO") are really backed by same data. 
    """
    
    """
    Inner class that stores the actual value
    """
    class __CryptMode(BaseEnumObject):

        def __init__(self, value):
            self.__value = value

        @property
        def value(self):
            return self.__value

        @property
        def name(self):
            return self.__value

        def __str__(self):
            return "CryptMode." + self.__value

    """
    allowed enum values
    """
    ECB = __CryptMode("ECB")
    CBC = __CryptMode("CBC")
    CBCNOPAD = __CryptMode("CBCNOPAD")
    CFB = __CryptMode("CFB")
    CTR = __CryptMode("CTR")
    OFB = __CryptMode("OFB")
    GCM = __CryptMode("GCM")
    CCM = __CryptMode("CCM")
    PKCS1_V15 = __CryptMode("PKCS1_V15")
    OAEP_MGF1_SHA1 = __CryptMode("OAEP_MGF1_SHA1")
    OAEP_MGF1_SHA256 = __CryptMode("OAEP_MGF1_SHA256")
    OAEP_MGF1_SHA384 = __CryptMode("OAEP_MGF1_SHA384")
    OAEP_MGF1_SHA512 = __CryptMode("OAEP_MGF1_SHA512")
    FPE = __CryptMode("FPE")
    KW = __CryptMode("KW")
    KWP = __CryptMode("KWP")

    """
    dictionary that keeps the enum value mapping for static access
    """
    __VALUES = dict()
    __VALUES["ECB"] = ECB
    __VALUES["CBC"] = CBC
    __VALUES["CBCNOPAD"] = CBCNOPAD
    __VALUES["CFB"] = CFB
    __VALUES["CTR"] = CTR
    __VALUES["OFB"] = OFB
    __VALUES["GCM"] = GCM
    __VALUES["CCM"] = CCM
    __VALUES["PKCS1_V15"] = PKCS1_V15
    __VALUES["OAEP_MGF1_SHA1"] = OAEP_MGF1_SHA1
    __VALUES["OAEP_MGF1_SHA256"] = OAEP_MGF1_SHA256
    __VALUES["OAEP_MGF1_SHA384"] = OAEP_MGF1_SHA384
    __VALUES["OAEP_MGF1_SHA512"] = OAEP_MGF1_SHA512
    __VALUES["FPE"] = FPE
    __VALUES["KW"] = KW
    __VALUES["KWP"] = KWP

    def __init__(self, name):
        if name in CryptMode.__VALUES:
            self.__instance = CryptMode.__VALUES[name]
        else:
            new_value = CryptMode.__CryptMode(name)
            CryptMode.__VALUES[name] = new_value
            self.__instance = new_value

    @property
    def value(self):
        return self.__instance.value

    @property
    def name(self):
        return self.__instance.name

    def __str__(self):
        return "CryptMode." + self.__instance.name

    """ 
    This is to ensure equals work for both static defined values and client defined ones.
    """
    def __eq__(self, other):
        if (isinstance(self, CryptMode) or isinstance(self, CryptMode.__CryptMode)) and \
                (isinstance(other, CryptMode) or isinstance(other, CryptMode.__CryptMode)):
                return self.value == other.value

        return False

    def __ne__(self, other):
        if (isinstance(self, CryptMode) or isinstance(self, CryptMode.__CryptMode)) and \
                (isinstance(other, CryptMode) or isinstance(other, CryptMode.__CryptMode)):
                return self.value != other.value

        return True


