# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re

from .base_enum_object import BaseEnumObject

# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class EllipticCurve(BaseEnumObject):
    """
    Identifies a standardized elliptic curve. Required for operations involving EC keys.

    Enumeration values::
        EllipticCurve.SECP192K1 = "SecP192K1"
        EllipticCurve.SECP224K1 = "SecP224K1"
        EllipticCurve.SECP256K1 = "SecP256K1"
        EllipticCurve.NISTP192 = "NistP192"
        EllipticCurve.NISTP224 = "NistP224"
        EllipticCurve.NISTP256 = "NistP256"
        EllipticCurve.NISTP384 = "NistP384"
        EllipticCurve.NISTP521 = "NistP521"
        EllipticCurve.GOST256A = "Gost256A"
        EllipticCurve.ED25519 = "Ed25519"
        EllipticCurve.X25519 = "X25519"
        EllipticCurve.X448 = "X448"

    This class doesnt use python standard enumeration since they dont support unknown values. 
    
    This is an object of type BaseEnumObject and provides similar functionality as a String Enumeration.
    
    Get a standard instance of enum: EllipticCurve.FOO or EllipticCurve("FOO")
    Get non standard instance of enum: EllipticCurve("BAR")
    Enum instance to String value: EllipticCurve.FOO.value , EllipticCurve.FOO.name (Gives "FOO")
    Equality: EllipticCurve.FOO == EllipticCurve("FOO") , EllipticCurve.FOO != EllipticCurve.BAR
    Provides str func:  str(EllipticCurve.FOO) == "EllipticCurve.FOO"
    
    Also the class maintains a static dict of values. hence EllipticCurve.FOO and EllipticCurve("FOO") are really backed by same data. 
    """
    
    """
    Inner class that stores the actual value
    """
    class __EllipticCurve(BaseEnumObject):

        def __init__(self, value):
            self.__value = value

        @property
        def value(self):
            return self.__value

        @property
        def name(self):
            return self.__value

        def __str__(self):
            return "EllipticCurve." + self.__value

    """
    allowed enum values
    """
    SECP192K1 = __EllipticCurve("SecP192K1")
    SECP224K1 = __EllipticCurve("SecP224K1")
    SECP256K1 = __EllipticCurve("SecP256K1")
    NISTP192 = __EllipticCurve("NistP192")
    NISTP224 = __EllipticCurve("NistP224")
    NISTP256 = __EllipticCurve("NistP256")
    NISTP384 = __EllipticCurve("NistP384")
    NISTP521 = __EllipticCurve("NistP521")
    GOST256A = __EllipticCurve("Gost256A")
    ED25519 = __EllipticCurve("Ed25519")
    X25519 = __EllipticCurve("X25519")
    X448 = __EllipticCurve("X448")

    """
    dictionary that keeps the enum value mapping for static access
    """
    __VALUES = dict()
    __VALUES["SecP192K1"] = SECP192K1
    __VALUES["SecP224K1"] = SECP224K1
    __VALUES["SecP256K1"] = SECP256K1
    __VALUES["NistP192"] = NISTP192
    __VALUES["NistP224"] = NISTP224
    __VALUES["NistP256"] = NISTP256
    __VALUES["NistP384"] = NISTP384
    __VALUES["NistP521"] = NISTP521
    __VALUES["Gost256A"] = GOST256A
    __VALUES["Ed25519"] = ED25519
    __VALUES["X25519"] = X25519
    __VALUES["X448"] = X448

    def __init__(self, name):
        if name in EllipticCurve.__VALUES:
            self.__instance = EllipticCurve.__VALUES[name]
        else:
            new_value = EllipticCurve.__EllipticCurve(name)
            EllipticCurve.__VALUES[name] = new_value
            self.__instance = new_value

    @property
    def value(self):
        return self.__instance.value

    @property
    def name(self):
        return self.__instance.name

    def __str__(self):
        return "EllipticCurve." + self.__instance.name

    """ 
    This is to ensure equals work for both static defined values and client defined ones.
    """
    def __eq__(self, other):
        if (isinstance(self, EllipticCurve) or isinstance(self, EllipticCurve.__EllipticCurve)) and \
                (isinstance(other, EllipticCurve) or isinstance(other, EllipticCurve.__EllipticCurve)):
                return self.value == other.value

        return False

    def __ne__(self, other):
        if (isinstance(self, EllipticCurve) or isinstance(self, EllipticCurve.__EllipticCurve)) and \
                (isinstance(other, EllipticCurve) or isinstance(other, EllipticCurve.__EllipticCurve)):
                return self.value != other.value

        return True


