# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re




# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class EncryptInitRequest(object):
    """
    @undocumented: swagger_types
    @undocumented: attribute_map
    @undocumented: to_dict
    @undocumented: to_str
    @undocumented: __repr__
    @undocumented: __eq__
    @undocumented: __ne__
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'alg': 'ObjectType',
        'mode': 'CipherMode',
        'iv': 'bytearray',
        'ad': 'bytearray'
    }

    attribute_map = {
        'alg': 'alg',
        'mode': 'mode',
        'iv': 'iv',
        'ad': 'ad'
    }

    def __init__(self, alg=None, mode=None, iv=None, ad=None):
        """
        EncryptInitRequest - a model defined in Swagger
        """

        self._alg = None
        self._mode = None
        self._iv = None
        self._ad = None

        self.alg = alg
        if mode is not None:
          self.mode = mode
        if iv is not None:
          self.iv = iv
        if ad is not None:
          self.ad = ad

    @property
    def alg(self):
        """
        Gets the alg of this EncryptInitRequest.

        Type: L{ObjectType}
        """
        return self._alg

    @alg.setter
    def alg(self, alg):
        """
        Sets the alg of this EncryptInitRequest.
        """

        self._alg = alg

    @property
    def mode(self):
        """
        Gets the mode of this EncryptInitRequest.

        Type: L{CipherMode}
        """
        return self._mode

    @mode.setter
    def mode(self, mode):
        """
        Sets the mode of this EncryptInitRequest.
        """

        self._mode = mode

    @property
    def iv(self):
        """
        Gets the iv of this EncryptInitRequest.
        For symmetric ciphers, this value will be used for the cipher initialization value. If not provided, SDKMS will generate a random iv and return it in the response. If provided, iv length must match the length required by the cipher and mode. 

        Type: L{bytearray}
        """
        return self._iv

    @iv.setter
    def iv(self, iv):
        """
        Sets the iv of this EncryptInitRequest.
        For symmetric ciphers, this value will be used for the cipher initialization value. If not provided, SDKMS will generate a random iv and return it in the response. If provided, iv length must match the length required by the cipher and mode. 
        """

        if not isinstance(iv, bytearray):
            raise ValueError("Invalid value for `iv`, `iv` must be a bytearray")
        self._iv = iv

    @property
    def ad(self):
        """
        Gets the ad of this EncryptInitRequest.
        For symmetric ciphers with cipher mode GCM or CCM, this optionally specifies the authenticated data used by the cipher. This field must not be provided with other cipher modes. 

        Type: L{bytearray}
        """
        return self._ad

    @ad.setter
    def ad(self, ad):
        """
        Sets the ad of this EncryptInitRequest.
        For symmetric ciphers with cipher mode GCM or CCM, this optionally specifies the authenticated data used by the cipher. This field must not be provided with other cipher modes. 
        """

        if not isinstance(ad, bytearray):
            raise ValueError("Invalid value for `ad`, `ad` must be a bytearray")
        self._ad = ad

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, EncryptInitRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

