# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re




# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class U2fAddDeviceRequest(object):
    """
    @undocumented: swagger_types
    @undocumented: attribute_map
    @undocumented: to_dict
    @undocumented: to_str
    @undocumented: __repr__
    @undocumented: __eq__
    @undocumented: __ne__
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'registration_data': 'str',
        'client_data': 'str',
        'version': 'str'
    }

    attribute_map = {
        'name': 'name',
        'registration_data': 'registrationData',
        'client_data': 'clientData',
        'version': 'version'
    }

    def __init__(self, name=None, registration_data=None, client_data=None, version=None):
        """
        U2fAddDeviceRequest - a model defined in Swagger
        """

        self._name = None
        self._registration_data = None
        self._client_data = None
        self._version = None

        self.name = name
        self.registration_data = registration_data
        self.client_data = client_data
        self.version = version

    @property
    def name(self):
        """
        Gets the name of this U2fAddDeviceRequest.

        Type: L{str}
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this U2fAddDeviceRequest.
        """

        self._name = name

    @property
    def registration_data(self):
        """
        Gets the registration_data of this U2fAddDeviceRequest.

        Type: L{str}
        """
        return self._registration_data

    @registration_data.setter
    def registration_data(self, registration_data):
        """
        Sets the registration_data of this U2fAddDeviceRequest.
        """

        self._registration_data = registration_data

    @property
    def client_data(self):
        """
        Gets the client_data of this U2fAddDeviceRequest.

        Type: L{str}
        """
        return self._client_data

    @client_data.setter
    def client_data(self, client_data):
        """
        Sets the client_data of this U2fAddDeviceRequest.
        """

        self._client_data = client_data

    @property
    def version(self):
        """
        Gets the version of this U2fAddDeviceRequest.

        Type: L{str}
        """
        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this U2fAddDeviceRequest.
        """

        self._version = version

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, U2fAddDeviceRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

