# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from __future__ import absolute_import

import os
import sys
import unittest

import sdkms/v1
from sdkms/v1.rest import ApiException
from sdkms/v1.apis.users_api import UsersApi


class TestUsersApi(unittest.TestCase):
    """ UsersApi unit test stubs """

    def setUp(self):
        self.api = sdkms/v1.apis.users_api.UsersApi()

    def tearDown(self):
        pass

    def test_change_password(self):
        """
        Test case for change_password

        Change user password
        """
        pass

    def test_confirm_email(self):
        """
        Test case for confirm_email

        Confirms user's email address
        """
        pass

    def test_create_user(self):
        """
        Test case for create_user

        Create a new user
        """
        pass

    def test_delete_user(self):
        """
        Test case for delete_user

        Removed user's association with an account
        """
        pass

    def test_delete_user_account(self):
        """
        Test case for delete_user_account

        Completely delete a user profile from system
        """
        pass

    def test_forgot_password(self):
        """
        Test case for forgot_password

        Initiate password reset sequence for a user
        """
        pass

    def test_get_user(self):
        """
        Test case for get_user

        Get a specific user
        """
        pass

    def test_get_user_account(self):
        """
        Test case for get_user_account

        Get account information for the user
        """
        pass

    def test_get_users(self):
        """
        Test case for get_users

        Get all users
        """
        pass

    def test_invite_user(self):
        """
        Test case for invite_user

        Invite a user
        """
        pass

    def test_process_invitations(self):
        """
        Test case for process_invitations

        Process a user's pending account invitations
        """
        pass

    def test_resend_confirm_email(self):
        """
        Test case for resend_confirm_email

        Resend email with link to confirm user's email address
        """
        pass

    def test_resend_invitation(self):
        """
        Test case for resend_invitation

        Resend invite to the user to join a specific account
        """
        pass

    def test_reset_password(self):
        """
        Test case for reset_password

        Reset a user's password
        """
        pass

    def test_update_user(self):
        """
        Test case for update_user

        Update user
        """
        pass

    def test_validate_password_reset_token(self):
        """
        Test case for validate_password_reset_token

        Validates password reset token for the user
        """
        pass


if __name__ == '__main__':
    unittest.main()
